[arch-commits] Commit in dkms/repos (17 files)
Sébastien Luttringer
seblu at gemini.archlinux.org
Mon Nov 15 11:46:25 UTC 2021
Date: Monday, November 15, 2021 @ 11:46:25
Author: seblu
Revision: 428525
db-move: moved dkms from [testing] to [extra] (any)
Added:
dkms/repos/extra-any/0001-Fix-creation-of-temp-build-dir.patch
(from rev 428524, dkms/repos/testing-any/0001-Fix-creation-of-temp-build-dir.patch)
dkms/repos/extra-any/PKGBUILD
(from rev 428524, dkms/repos/testing-any/PKGBUILD)
dkms/repos/extra-any/PKGBUILD.26
(from rev 428524, dkms/repos/testing-any/PKGBUILD.26)
dkms/repos/extra-any/dkms.install
(from rev 428524, dkms/repos/testing-any/dkms.install)
dkms/repos/extra-any/hook.install
(from rev 428524, dkms/repos/testing-any/hook.install)
dkms/repos/extra-any/hook.remove
(from rev 428524, dkms/repos/testing-any/hook.remove)
dkms/repos/extra-any/hook.sh
(from rev 428524, dkms/repos/testing-any/hook.sh)
dkms/repos/extra-any/hook.upgrade
(from rev 428524, dkms/repos/testing-any/hook.upgrade)
Deleted:
dkms/repos/extra-any/0001-Revert-Make-newly-installed-modules-available-immedi.patch
dkms/repos/extra-any/PKGBUILD
dkms/repos/extra-any/PKGBUILD.26
dkms/repos/extra-any/dkms.install
dkms/repos/extra-any/hook.install
dkms/repos/extra-any/hook.remove
dkms/repos/extra-any/hook.sh
dkms/repos/extra-any/hook.upgrade
dkms/repos/testing-any/
---------------------------------------------------------------------------+
/PKGBUILD | 75 ++
/PKGBUILD.26 | 69 ++
/dkms.install | 13
/hook.install | 14
/hook.remove | 13
/hook.sh | 303 ++++++++++
/hook.upgrade | 13
extra-any/0001-Fix-creation-of-temp-build-dir.patch | 29
extra-any/0001-Revert-Make-newly-installed-modules-available-immedi.patch | 31 -
extra-any/PKGBUILD | 73 --
extra-any/PKGBUILD.26 | 69 --
extra-any/dkms.install | 13
extra-any/hook.install | 14
extra-any/hook.remove | 13
extra-any/hook.sh | 251 --------
extra-any/hook.upgrade | 13
16 files changed, 529 insertions(+), 477 deletions(-)
Copied: dkms/repos/extra-any/0001-Fix-creation-of-temp-build-dir.patch (from rev 428524, dkms/repos/testing-any/0001-Fix-creation-of-temp-build-dir.patch)
===================================================================
--- extra-any/0001-Fix-creation-of-temp-build-dir.patch (rev 0)
+++ extra-any/0001-Fix-creation-of-temp-build-dir.patch 2021-11-15 11:46:25 UTC (rev 428525)
@@ -0,0 +1,29 @@
+From 0000000000000000000000000000000000000000 Mon Sep 17 00:00:00 2001
+From: "Jan Alexander Steffens (heftig)" <heftig at archlinux.org>
+Date: Fri, 12 Nov 2021 20:25:22 +0000
+Subject: [PATCH] Fix creation of temp build dir
+
+Since `$source_dir` is just a symlink to the actual source directory,
+using `cp -a` on it just copies the symlink instead of the contents.
+
+This makes the build fail when the source directory isn't writable.
+
+Commit d038a604bf525b01d7bd12b98706b1f861e4ea27 broke this when it
+dropped the trailing slash.
+---
+ dkms.in | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/dkms.in b/dkms.in
+index c907d1f60a61..115eb062a382 100644
+--- a/dkms.in
++++ b/dkms.in
+@@ -872,7 +872,7 @@ prepare_build()
+
+ # Set up temporary build directory for build
+ rm -rf "$build_dir"
+- cp -a "$source_dir" "$build_dir"
++ cp -a "$source_dir/" "$build_dir"
+
+ cd "$build_dir"
+
Deleted: extra-any/0001-Revert-Make-newly-installed-modules-available-immedi.patch
===================================================================
--- extra-any/0001-Revert-Make-newly-installed-modules-available-immedi.patch 2021-11-15 09:53:58 UTC (rev 428524)
+++ extra-any/0001-Revert-Make-newly-installed-modules-available-immedi.patch 2021-11-15 11:46:25 UTC (rev 428525)
@@ -1,31 +0,0 @@
-From ca38ccd38c69a096dafa51c426ee3548980d5e2a Mon Sep 17 00:00:00 2001
-From: =?UTF-8?q?S=C3=A9bastien=20Luttringer?= <seblu at seblu.net>
-Date: Sat, 8 Jul 2017 15:50:55 +0200
-Subject: [PATCH] Revert "Make newly installed modules available immediately"
-To: dkms-devel at dell.com
-
-This reverts commit f5bfb12fef1fc06e56355cdba500eaa98d4e6aa8.
----
- dkms | 6 ------
- 1 file changed, 6 deletions(-)
-
-diff --git a/dkms b/dkms
-index a6cedc8..3ff71d5 100644
---- a/dkms
-+++ b/dkms
-@@ -1522,12 +1522,6 @@ install_module()
- exit 6
- }
-
-- # Make the newly installed modules available immediately
-- find /sys/devices -name modalias -print0 | xargs -0 cat | xargs modprobe -a -b -q
-- if [ -f /lib/systemd/system/systemd-modules-load.service ]; then
-- systemctl restart systemd-modules-load.service
-- fi
--
- # Do remake_initrd things (save old initrd)
- [[ $remake_initrd ]] && ! make_initrd "$kernelver" "$arch" && {
- do_uninstall "$kernelver" "$arch"
---
-Sébastien "Seblu" Luttringer
-
Deleted: extra-any/PKGBUILD
===================================================================
--- extra-any/PKGBUILD 2021-11-15 09:53:58 UTC (rev 428524)
+++ extra-any/PKGBUILD 2021-11-15 11:46:25 UTC (rev 428525)
@@ -1,73 +0,0 @@
-# Maintainer: Sébastien Luttringer
-# Contributor: Balwinder S "bsd" Dheeman (bdheeman AT gmail.com)
-
-pkgname=dkms
-pkgver=2.8.6
-pkgrel=2
-pkgdesc='Dynamic Kernel Modules System'
-arch=('any')
-url='https://github.com/dell/dkms'
-license=('GPL2')
-depends=('bash' 'kmod' 'gcc' 'make' 'patch')
-makedepends=('git')
-optdepends=('linux-headers: build modules against the Arch kernel'
- 'linux-lts-headers: build modules against the LTS kernel'
- 'linux-zen-headers: build modules against the ZEN kernel'
- 'linux-hardened-headers: build modules against the HARDENED kernel')
-backup=('etc/dkms/framework.conf')
-install=$pkgname.install
-source=("git+https://github.com/dell/dkms.git#tag=v$pkgver"
- 'hook.install'
- 'hook.remove'
- 'hook.upgrade'
- 'hook.sh'
- '0001-Revert-Make-newly-installed-modules-available-immedi.patch')
-sha256sums=('SKIP'
- '047e0e46967e98fbf3ff8860a80f259c28693d5989373d5a5395714495b59844'
- 'ae5483980db914d52bff981ed83356c85679dd7e6e8f73bdd94265f065014c73'
- 'd61d94532789928085a8494ba039c59244cfb3bfd47deaf21bcbe54a2243dc45'
- '55209947f6266dc7f29b82f3d2635a6b92f6e175d59571dca4d2fd435dffab4a'
- '124b821b1b44ba365d915945825bcf32c1077655c3a98eb1644de56b6abfcd09')
-
-prepare() {
- cd dkms
-
- # apply patch from the source array (should be a pacman feature)
- local filename
- for filename in "${source[@]}"; do
- if [[ "$filename" =~ \.patch$ ]]; then
- msg2 "Applying patch ${filename##*/}"
- patch -p1 -N -i "$srcdir/${filename##*/}"
- fi
- done
-
- # /usr move
- msg2 '/usr move patching'
- for i in dkms{,_framework.conf,.bash-completion,.8,_common.postinst}; do
- sed -ri 's,/lib/modules,/usr/lib/modules,g' "$i"
- done
-}
-
-package() {
- # alpm hooks
- install -D -m 644 hook.install "$pkgdir/usr/share/libalpm/hooks/70-dkms-install.hook"
- # both upgrade and remove hooks are removing dkms modules.
- # remove always call depmod while upgrade never, as install will later.
- # upgrade is run before remove in order to have the cleanest depmod file,
- # if something goes wrong before the depmod call in install hook.
- install -D -m 644 hook.upgrade "$pkgdir/usr/share/libalpm/hooks/70-dkms-upgrade.hook"
- install -D -m 644 hook.remove "$pkgdir/usr/share/libalpm/hooks/71-dkms-remove.hook"
- # hook helper
- install -D -m 755 hook.sh "$pkgdir/usr/lib/dkms/alpm-hook"
- # upstream installer
- cd dkms
- # we don't need kconf files, so we install them outside $pkgdir
- make \
- DESTDIR="$pkgdir" \
- SBIN="$pkgdir/usr/bin" \
- BASHDIR="$pkgdir/usr/share/bash-completion/completions" \
- KCONF="$srcdir"/kconf \
- install
-}
-
-# vim:set ts=2 sw=2 et:
Copied: dkms/repos/extra-any/PKGBUILD (from rev 428524, dkms/repos/testing-any/PKGBUILD)
===================================================================
--- extra-any/PKGBUILD (rev 0)
+++ extra-any/PKGBUILD 2021-11-15 11:46:25 UTC (rev 428525)
@@ -0,0 +1,75 @@
+# Maintainer: Sébastien Luttringer
+# Contributor: Balwinder S "bsd" Dheeman (bdheeman AT gmail.com)
+
+pkgname=dkms
+pkgver=3.0.0
+pkgrel=2
+pkgdesc='Dynamic Kernel Modules System'
+arch=('any')
+url='https://github.com/dell/dkms'
+license=('GPL2')
+depends=('coreutils' 'bash' 'gawk' 'sed' 'kmod' 'gcc' 'make' 'patch')
+makedepends=('git')
+optdepends=('linux-headers: build modules against the Arch kernel'
+ 'linux-lts-headers: build modules against the LTS kernel'
+ 'linux-zen-headers: build modules against the ZEN kernel'
+ 'linux-hardened-headers: build modules against the HARDENED kernel')
+backup=('etc/dkms/framework.conf')
+install=$pkgname.install
+source=("git+https://github.com/dell/dkms.git#tag=v$pkgver"
+ '0001-Fix-creation-of-temp-build-dir.patch'
+ 'hook.install'
+ 'hook.remove'
+ 'hook.upgrade'
+ 'hook.sh')
+sha256sums=('SKIP'
+ 'dfc112922e19ed1ea053132727a8431295365a2372666b44788a69b035459c15'
+ 'acdc5b45cc018cea04ee1aec56fd8fc3a2de62cf7bc41acf53b3790872120998'
+ '326515cc7d00f93760beb844434ca7442caf7a9424614aa95a8f6d1ab79e15df'
+ '4f8dff7716e73a8bba885638f12e3cdc9e87daec1896f75e700b981527e43870'
+ 'c1b4a4e2e4e0e0e59ee0887403e79d60b209f3878dbbec6612573f13b90cce01')
+
+prepare() {
+ cd dkms
+
+ # apply patch from the source array (should be a pacman feature)
+ local filename
+ for filename in "${source[@]}"; do
+ if [[ "$filename" =~ \.patch$ ]]; then
+ msg2 "Applying patch ${filename##*/}"
+ patch -p1 -N -i "$srcdir/${filename##*/}"
+ fi
+ done
+
+ # /usr move
+ msg2 '/usr move patching'
+ for i in dkms{.in,.8.in,_framework.conf,.bash-completion,_common.postinst} sign_helper.sh; do
+ sed -ri 's,/lib/modules,/usr/lib/modules,g' "$i"
+ done
+}
+
+package() {
+ # alpm hooks
+ install -D -m 644 hook.install "$pkgdir/usr/share/libalpm/hooks/70-dkms-install.hook"
+ # both upgrade and remove hooks are removing dkms modules.
+ # remove always call depmod while upgrade never, as install will later.
+ # upgrade is run before remove in order to have the cleanest depmod file,
+ # if something goes wrong before the depmod call in install hook.
+ install -D -m 644 hook.upgrade "$pkgdir/usr/share/libalpm/hooks/70-dkms-upgrade.hook"
+ install -D -m 644 hook.remove "$pkgdir/usr/share/libalpm/hooks/71-dkms-remove.hook"
+ # hook helper
+ install -D -m 755 hook.sh "$pkgdir/usr/share/libalpm/scripts/dkms"
+ # upstream installer
+ cd dkms
+ # we don't need kconf files and libdir is only for debian stuff, so
+ # we install them outside of $pkgdir
+ make \
+ DESTDIR="$pkgdir" \
+ SBIN="$pkgdir/usr/bin" \
+ BASHDIR="$pkgdir/usr/share/bash-completion/completions" \
+ KCONF="$srcdir"/trash \
+ LIBDIR="$srcdir"/trash \
+ install
+}
+
+# vim:set ts=2 sw=2 et:
Deleted: extra-any/PKGBUILD.26
===================================================================
--- extra-any/PKGBUILD.26 2021-11-15 09:53:58 UTC (rev 428524)
+++ extra-any/PKGBUILD.26 2021-11-15 11:46:25 UTC (rev 428525)
@@ -1,69 +0,0 @@
-# Maintainer: Sébastien Luttringer
-# Contributor: Balwinder S "bsd" Dheeman (bdheeman AT gmail.com)
-
-pkgname=dkms
-pkgver=2.6.1
-pkgrel=1
-pkgdesc='Dynamic Kernel Modules System'
-arch=('any')
-url='https://github.com/dell/dkms'
-license=('GPL2')
-depends=('bash' 'kmod' 'gcc' 'make' 'patch')
-makedepends=('git')
-optdepends=('linux-headers: build modules against the Arch kernel'
- 'linux-lts-headers: build modules against the LTS kernel'
- 'linux-zen-headers: build modules against the ZEN kernel'
- 'linux-hardened-headers: build modules against the HARDENED kernel')
-backup=('etc/dkms/framework.conf')
-install=$pkgname.install
-source=("git+https://github.com/dell/dkms.git#tag=v$pkgver"
- 'hook.install'
- 'hook.remove'
- 'hook.sh'
- '0001-Revert-Make-newly-installed-modules-available-immedi.patch'
- '0002-Revert-Fix-to-run-under-BusyBox-shell.patch'
- '0003-Fix-version-check-when-installing-modules.patch')
-md5sums=('SKIP'
- '90f1486e0af9aab85e8c60d456802c63'
- '2e8ffd0c2ddec02872d0234befd129fd'
- '80632f6a454b35bcade2bed287f13c7b'
- 'd3b91ef709f567a375f4bbdbd3291d2b'
- '4342b5e9020a52a73a63e7897ead5405'
- '00813655321b8fc256eda737ca0622ef')
-
-prepare() {
- cd dkms
-
- # apply patch from the source array (should be a pacman feature)
- local filename
- for filename in "${source[@]}"; do
- if [[ "$filename" =~ \.patch$ ]]; then
- msg2 "Applying patch ${filename##*/}"
- patch -p1 -N -i "$srcdir/${filename##*/}"
- fi
- done
-
- # /usr move
- msg2 '/usr move patching'
- for i in dkms{,_framework.conf,.bash-completion,.8,_common.postinst}; do
- sed -ri 's,/lib/modules,/usr/lib/modules,g' "$i"
- done
-}
-
-package() {
- # alpm hook
- install -D -m 644 hook.install "$pkgdir/usr/share/libalpm/hooks/70-dkms-install.hook"
- install -D -m 644 hook.remove "$pkgdir/usr/share/libalpm/hooks/70-dkms-remove.hook"
- install -D -m 755 hook.sh "$pkgdir/usr/lib/dkms/alpm-hook"
- # upstream installer
- cd dkms
- # we don't need kconf files, so we install them outside $pkgdir
- make \
- DESTDIR="$pkgdir" \
- SBIN="$pkgdir/usr/bin" \
- BASHDIR="$pkgdir/usr/share/bash-completion/completions" \
- KCONF="$srcdir"/kconf \
- install
-}
-
-# vim:set ts=2 sw=2 et:
Copied: dkms/repos/extra-any/PKGBUILD.26 (from rev 428524, dkms/repos/testing-any/PKGBUILD.26)
===================================================================
--- extra-any/PKGBUILD.26 (rev 0)
+++ extra-any/PKGBUILD.26 2021-11-15 11:46:25 UTC (rev 428525)
@@ -0,0 +1,69 @@
+# Maintainer: Sébastien Luttringer
+# Contributor: Balwinder S "bsd" Dheeman (bdheeman AT gmail.com)
+
+pkgname=dkms
+pkgver=2.6.1
+pkgrel=1
+pkgdesc='Dynamic Kernel Modules System'
+arch=('any')
+url='https://github.com/dell/dkms'
+license=('GPL2')
+depends=('bash' 'kmod' 'gcc' 'make' 'patch')
+makedepends=('git')
+optdepends=('linux-headers: build modules against the Arch kernel'
+ 'linux-lts-headers: build modules against the LTS kernel'
+ 'linux-zen-headers: build modules against the ZEN kernel'
+ 'linux-hardened-headers: build modules against the HARDENED kernel')
+backup=('etc/dkms/framework.conf')
+install=$pkgname.install
+source=("git+https://github.com/dell/dkms.git#tag=v$pkgver"
+ 'hook.install'
+ 'hook.remove'
+ 'hook.sh'
+ '0001-Revert-Make-newly-installed-modules-available-immedi.patch'
+ '0002-Revert-Fix-to-run-under-BusyBox-shell.patch'
+ '0003-Fix-version-check-when-installing-modules.patch')
+md5sums=('SKIP'
+ '90f1486e0af9aab85e8c60d456802c63'
+ '2e8ffd0c2ddec02872d0234befd129fd'
+ '80632f6a454b35bcade2bed287f13c7b'
+ 'd3b91ef709f567a375f4bbdbd3291d2b'
+ '4342b5e9020a52a73a63e7897ead5405'
+ '00813655321b8fc256eda737ca0622ef')
+
+prepare() {
+ cd dkms
+
+ # apply patch from the source array (should be a pacman feature)
+ local filename
+ for filename in "${source[@]}"; do
+ if [[ "$filename" =~ \.patch$ ]]; then
+ msg2 "Applying patch ${filename##*/}"
+ patch -p1 -N -i "$srcdir/${filename##*/}"
+ fi
+ done
+
+ # /usr move
+ msg2 '/usr move patching'
+ for i in dkms{,_framework.conf,.bash-completion,.8,_common.postinst}; do
+ sed -ri 's,/lib/modules,/usr/lib/modules,g' "$i"
+ done
+}
+
+package() {
+ # alpm hook
+ install -D -m 644 hook.install "$pkgdir/usr/share/libalpm/hooks/70-dkms-install.hook"
+ install -D -m 644 hook.remove "$pkgdir/usr/share/libalpm/hooks/70-dkms-remove.hook"
+ install -D -m 755 hook.sh "$pkgdir/usr/lib/dkms/alpm-hook"
+ # upstream installer
+ cd dkms
+ # we don't need kconf files, so we install them outside $pkgdir
+ make \
+ DESTDIR="$pkgdir" \
+ SBIN="$pkgdir/usr/bin" \
+ BASHDIR="$pkgdir/usr/share/bash-completion/completions" \
+ KCONF="$srcdir"/kconf \
+ install
+}
+
+# vim:set ts=2 sw=2 et:
Deleted: extra-any/dkms.install
===================================================================
--- extra-any/dkms.install 2021-11-15 09:53:58 UTC (rev 428524)
+++ extra-any/dkms.install 2021-11-15 11:46:25 UTC (rev 428525)
@@ -1,13 +0,0 @@
-#!/bin/bash
-
-# arg 1: the new package version
-# arg 2: the old package version
-post_upgrade() {
- if (( "$(vercmp $2 '2.2.0.3+git151023-2')" < 0 )); then
- echo '===> dkms systemd startup service has been removed'
- echo '===> modules building is now handled by alpm hooks at install time'
- echo '===> startup modules loading must be done via modules-load.d'
- fi
-}
-
-# vim:set ts=2 sw=2 ft=sh et:
Copied: dkms/repos/extra-any/dkms.install (from rev 428524, dkms/repos/testing-any/dkms.install)
===================================================================
--- extra-any/dkms.install (rev 0)
+++ extra-any/dkms.install 2021-11-15 11:46:25 UTC (rev 428525)
@@ -0,0 +1,13 @@
+#!/bin/bash
+
+# arg 1: the new package version
+# arg 2: the old package version
+post_upgrade() {
+ if (( "$(vercmp $2 '2.2.0.3+git151023-2')" < 0 )); then
+ echo '===> dkms systemd startup service has been removed'
+ echo '===> modules building is now handled by alpm hooks at install time'
+ echo '===> startup modules loading must be done via modules-load.d'
+ fi
+}
+
+# vim:set ts=2 sw=2 ft=sh et:
Deleted: extra-any/hook.install
===================================================================
--- extra-any/hook.install 2021-11-15 09:53:58 UTC (rev 428524)
+++ extra-any/hook.install 2021-11-15 11:46:25 UTC (rev 428525)
@@ -1,14 +0,0 @@
-[Trigger]
-Operation = Install
-Operation = Upgrade
-Type = Path
-Target = usr/src/*/dkms.conf
-Target = usr/lib/modules/*/build/include/
-Target = usr/lib/modules/*/modules.alias
-
-[Action]
-Description = Install DKMS modules
-Depends = dkms
-When = PostTransaction
-Exec = /usr/lib/dkms/alpm-hook install
-NeedsTargets
Copied: dkms/repos/extra-any/hook.install (from rev 428524, dkms/repos/testing-any/hook.install)
===================================================================
--- extra-any/hook.install (rev 0)
+++ extra-any/hook.install 2021-11-15 11:46:25 UTC (rev 428525)
@@ -0,0 +1,14 @@
+[Trigger]
+Operation = Install
+Operation = Upgrade
+Type = Path
+Target = usr/src/*/dkms.conf
+Target = usr/lib/modules/*/build/include/
+Target = usr/lib/modules/*/modules.alias
+
+[Action]
+Description = Install DKMS modules
+Depends = dkms
+When = PostTransaction
+Exec = /usr/share/libalpm/scripts/dkms install
+NeedsTargets
Deleted: extra-any/hook.remove
===================================================================
--- extra-any/hook.remove 2021-11-15 09:53:58 UTC (rev 428524)
+++ extra-any/hook.remove 2021-11-15 11:46:25 UTC (rev 428525)
@@ -1,13 +0,0 @@
-[Trigger]
-Operation = Remove
-Type = Path
-Target = usr/src/*/dkms.conf
-Target = usr/lib/modules/*/build/include/
-Target = usr/lib/modules/*/modules.alias
-
-[Action]
-Description = Remove DKMS modules
-Depends = dkms
-When = PreTransaction
-Exec = /usr/lib/dkms/alpm-hook remove
-NeedsTargets
Copied: dkms/repos/extra-any/hook.remove (from rev 428524, dkms/repos/testing-any/hook.remove)
===================================================================
--- extra-any/hook.remove (rev 0)
+++ extra-any/hook.remove 2021-11-15 11:46:25 UTC (rev 428525)
@@ -0,0 +1,13 @@
+[Trigger]
+Operation = Remove
+Type = Path
+Target = usr/src/*/dkms.conf
+Target = usr/lib/modules/*/build/include/
+Target = usr/lib/modules/*/modules.alias
+
+[Action]
+Description = Remove DKMS modules
+Depends = dkms
+When = PreTransaction
+Exec = /usr/share/libalpm/scripts/dkms remove
+NeedsTargets
Deleted: extra-any/hook.sh
===================================================================
--- extra-any/hook.sh 2021-11-15 09:53:58 UTC (rev 428524)
+++ extra-any/hook.sh 2021-11-15 11:46:25 UTC (rev 428525)
@@ -1,251 +0,0 @@
-#!/bin/bash
-
-#
-# Copyright © 2018-2020, Sébastien Luttringer
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License
-# as published by the Free Software Foundation; either version 2
-# of the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-
-# display what to run and run it quietly
-run() {
- echo "==> $*"
- "$@" > /dev/null
- local ret=$?
- (( $ret )) && echo "==> Warning, \`$*' returned $ret"
- return $ret
-}
-
-# check whether the dependencies of a module are installed
-# $1: module name
-# $2: module version
-# $3: kernel version
-check_dependency() { (
- source "$source_tree/$1-$2/dkms.conf"
- local mod lines line
- for mod in "${BUILD_DEPENDS[@]}"; do
- mapfile lines < <(dkms status -m "$mod" -k "$3")
- for line in "${lines[@]}"; do
- [[ "$line" =~ "$mod/"[^,]+", $3, "[^:]+': installed' ]] && break 2
- done
- exit 1
- done
- exit 0
-) }
-
-# check whether the modules should be built with this kernel version
-# $1: module name
-# $2: module version
-# $3: kernel version
-check_buildexclusive() {
- local BUILD_EXCLUSIVE_KERNEL=$(source "$source_tree/$1-$2/dkms.conf"; printf '%s\n' "$BUILD_EXCLUSIVE_KERNEL")
- [[ "$3" =~ $BUILD_EXCLUSIVE_KERNEL ]]
-}
-
-# handle actions on module addition/upgrade/removal
-# $1: module name
-# $2: module version
-parse_module() {
- pushd "$install_tree" >/dev/null
- local path
- for path in */build/; do
- local kver="${path%%/*}"
- dkms_register "$1" "$2" "$kver"
- done
- popd >/dev/null
-}
-
-# handle actions on kernel addition/upgrade/removal
-# $1: kernel version
-parse_kernel() {
- local path
- for path in "$source_tree"/*-*/dkms.conf; do
- if [[ -f "$path" && "$path" =~ ^$source_tree/([^/]+)-([^/]+)/dkms\.conf$ ]]; then
- dkms_register "${BASH_REMATCH[1]}" "${BASH_REMATCH[2]}" "$1"
- fi
- done
-}
-
-# register a dkms module to install/remove
-# this function suppress echo call for a module
-# $1: module name, $2: module version, $3: kernel version
-dkms_register() {
- DKMS_MODULES["$1/$2/$3"]=''
-}
-
-# install registered modules
-dkms_install() {
- local nvk mod mver kver
- local -i retry=1
- local -A dmods=()
-
- while (( $retry > 0 )); do
- retry=0
- for nvk in "${!DKMS_MODULES[@]}"; do
- [[ "$nvk" =~ ([^/]+)/([^/]+)/(.+) ]]
- mod="${BASH_REMATCH[1]}"
- mver="${BASH_REMATCH[2]}"
- kver="${BASH_REMATCH[3]}"
- # do not build excluded modules
- if ! check_buildexclusive "$mod" "$mver" "$kver"; then
- unset DKMS_MODULES[$nvk]
- continue
- # skip modules with missing kernel headers
- elif [[ ! -d "$install_tree/$kver/build/include" ]]; then
- DKMS_MODULES[$nvk]='Missing kernel headers'
- continue
- # skip modules with missing kernel package
- elif [[ ! -d "$install_tree/$kver/kernel" ]]; then
- DKMS_MODULES[$nvk]='Missing kernel modules tree'
- continue
- # postpone modules with missing dependencies
- elif ! check_dependency "$mod" "$mver" "$kver"; then
- DKMS_MODULES[$nvk]='Missing dependency'
- continue
- fi
- # give it a try dkms
- run dkms install --no-depmod -m "$mod" -v "$mver" -k "$kver"
- dmods[$kver]=''
- unset DKMS_MODULES[$nvk]
- # maybe this module was a dep of another, so we retry
- retry=1
- done
- done
- # run depmod later for performance improvments
- if (( $DKMS_DEPMOD )); then
- for kver in "${!dmods[@]}"; do
- run depmod "$kver"
- done
- fi
-}
-
-# remove registered modules when built/installed
-# run depmod later for performance improvments
-dkms_remove() {
- local nvk mod mver kver state
- local -A dmods=()
- for nvk in "${!DKMS_MODULES[@]}"; do
- [[ "$nvk" =~ ([^/]+)/([^/]+)/(.+) ]]
- mod="${BASH_REMATCH[1]}"
- mver="${BASH_REMATCH[2]}"
- kver="${BASH_REMATCH[3]}"
- # do not remove excluded modules (n.b. display not found errors)
- if ! check_buildexclusive "$mod" "$mver" "$kver"; then
- unset DKMS_MODULES[$nvk]
- continue
- fi
- state=$(dkms status -m "$mod" -v "$mver" -k "$kver")
- if [[ "$state" =~ "$mod/$mver, $kver, "[^:]+": "(added|built|installed) ]]; then
- dmods[$kver]=''
- run dkms remove --no-depmod -m "$mod" -v "$mver" -k "$kver"
- if (( $? == 0 )); then
- unset DKMS_MODULES[$nvk]
- else
- DKMS_MODULES[$nvk]='dkms remove failed'
- fi
- else
- DKMS_MODULES[$nvk]='Not found in dkms status output'
- fi
- done
- # run depmod later for performance improvments
- if (( $DKMS_DEPMOD )); then
- for kver in "${!dmods[@]}"; do
- run depmod "$kver"
- done
- fi
-}
-
-# show information about failed modules
-show_errors() {
- local nvk mod kver
- for nvk in "${!DKMS_MODULES[@]}"; do
- mod=${nvk%/*}
- kver=${nvk##*/}
- echo "==> Unable to $DKMS_ACTION module $mod for kernel $kver: ${DKMS_MODULES[$nvk]}."
- done
-}
-
-# display hook usage and exit $1 (default 1)
-usage() {
- cat << EOF >&2
-usage: ${0##*/} <options> install|remove
-options: -D Do not run depmod
-EOF
- exit ${1:-1}
-}
-
-# emulated program entry point
-main() {
- [[ "$DKMS_ALPM_HOOK_DEBUG" ]] && set -x
-
- # prevent each dkms call from failing with authorization errors
- if (( EUID )); then
- echo 'You must be root to use this hook' >&2
- exit 1
- fi
-
- # parse command line options
- declare -i DKMS_DEPMOD=1
- local opt
- while getopts 'hD' opt; do
- case $opt in
- D) DKMS_DEPMOD=0;;
- *) usage;;
- esac
- done
- shift $((OPTIND - 1))
- (( $# != 1 )) && usage
-
- # register DKMS action
- case "$1" in
- install|remove)
- declare -r DKMS_ACTION="$1";;
- *) usage;;
- esac
-
- # dkms path from framework config
- # note: the alpm hooks which trigger this script use static path
- source_tree='/usr/src'
- install_tree='/usr/lib/modules'
- source /etc/dkms/framework.conf
-
- # check source_tree and install_tree exists
- local path
- for path in "$source_tree" "$install_tree"; do
- if [[ ! -d "$path" ]]; then
- echo "==> Missing mandatory directory: $path. Exiting!"
- return 1
- fi
- done
-
- # storage for DKMS modules to install/remove
- # we use associate arrays to prevent duplicate
- declare -A DKMS_MODULES
-
- # parse stdin paths to guess what do do
- while read -r path; do
- if [[ "/$path" =~ ^$source_tree/([^/]+)-([^/]+)/dkms\.conf$ ]]; then
- parse_module "${BASH_REMATCH[1]}" "${BASH_REMATCH[2]}"
- elif [[ "/$path" =~ ^$install_tree/([^/]+)/ ]]; then
- parse_kernel "${BASH_REMATCH[1]}"
- fi
- done
-
- dkms_$DKMS_ACTION
-
- show_errors
-
- return 0
-}
-
-main "$@"
Copied: dkms/repos/extra-any/hook.sh (from rev 428524, dkms/repos/testing-any/hook.sh)
===================================================================
--- extra-any/hook.sh (rev 0)
+++ extra-any/hook.sh 2021-11-15 11:46:25 UTC (rev 428525)
@@ -0,0 +1,303 @@
+#!/bin/bash
+
+#
+# Copyright © 2018-2021, Sébastien Luttringer
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+
+# display what to run and run it quietly
+run() {
+ echo "==> $*"
+ "$@" > /dev/null
+ local ret=$?
+ (( $ret )) && echo "==> WARNING: \`$*' exited $ret"
+ return $ret
+}
+
+# check whether the dependencies of a module are installed
+# $1: module name
+# $2: module version
+# $3: kernel version
+check_dependency() { (
+ source "$source_tree/$1-$2/dkms.conf"
+ local mod lines line
+ for mod in "${BUILD_DEPENDS[@]}"; do
+ mapfile lines < <(dkms status -m "$mod" -k "$3")
+ for line in "${lines[@]}"; do
+ [[ "$line" =~ "$mod/"[^,]+", $3, "[^:]+': installed' ]] && break 2
+ done
+ exit 1
+ done
+ exit 0
+) }
+
+# check whether the modules should be built with this kernel version
+# $1: module name
+# $2: module version
+# $3: kernel version
+check_buildexclusive() {
+ local BUILD_EXCLUSIVE_KERNEL=$(source "$source_tree/$1-$2/dkms.conf"; printf '%s\n' "$BUILD_EXCLUSIVE_KERNEL")
+ [[ "$3" =~ $BUILD_EXCLUSIVE_KERNEL ]]
+}
+
+# list all kernel versions
+all_kver() {
+ pushd "$install_tree" >/dev/null
+ local path
+ for path in */build/; do
+ echo "${path%%/*}"
+ done
+ popd >/dev/null
+}
+
+# list all module name/version for a specific kernel version
+# $1: kernel version
+all_nv_from_kver() {
+ local path
+ for path in "$source_tree"/*-*/dkms.conf; do
+ if [[ -f "$path" && "$path" =~ ^$source_tree/([^/]+)-([^/]+)/dkms\.conf$ ]]; then
+ echo "${BASH_REMATCH[1]}/${BASH_REMATCH[2]}"
+ fi
+ done
+}
+
+# list of modules/version for installed/built kernel version
+# $1: kernel version
+built_nv_from_kver() {
+ local line
+ dkms status -k "$1" | while read -r line; do
+ if [[ "$line" =~ ^([^/]+/[^,]+)", $1, "[^:]+": "(built|installed) ]]; then
+ echo "${BASH_REMATCH[1]}"
+ fi
+ done
+}
+
+# list installed or built kernel version for a specific module version
+# $1 : module name/module version
+built_kver_from_nv() {
+ local line
+ dkms status "$1" | while read -r line; do
+ if [[ "$line" =~ ^"$1, "([^,]+)", "[^:]+": "(built|installed) ]]; then
+ echo "${BASH_REMATCH[1]}"
+ fi
+ done
+}
+
+# install registered modules
+dkms_install() {
+ # list of modules to build for a specific kernel
+ local -A tobuild=()
+
+ # add new/updated modules for all kernels to the build list
+ local nv kver
+ for nv in "${!DKMS_MODULES[@]}"; do
+ for kver in $(all_kver); do
+ tobuild["$nv/$kver"]=''
+ done
+ done
+ # add modules for new/updated kernels to the build list
+ for kver in "${!KERNEL_VERSIONS[@]}"; do
+ for nv in $(all_nv_from_kver "$kver"); do
+ tobuild["$nv/$kver"]=''
+ done
+ done
+
+ # list of kver which requires depmod refresh
+ local -A depmods=()
+
+ # let's build and install
+ local nvk mod mver
+ local -i retry=1
+ while (( $retry > 0 )); do
+ retry=0
+ for nvk in "${!tobuild[@]}"; do
+ [[ "$nvk" =~ ([^/]+)/([^/]+)/(.+) ]] || continue
+ mod="${BASH_REMATCH[1]}"
+ mver="${BASH_REMATCH[2]}"
+ kver="${BASH_REMATCH[3]}"
+ # do not build excluded modules
+ if ! check_buildexclusive "$mod" "$mver" "$kver"; then
+ unset tobuild[$nvk]
+ continue
+ # skip modules with missing kernel headers
+ elif [[ ! -d "$install_tree/$kver/build/include" ]]; then
+ ERROR_MESSAGES+=("Missing $kver kernel headers for module $mod/$mver.")
+ unset tobuild[$nvk]
+ continue
+ # skip modules with missing kernel package
+ elif [[ ! -d "$install_tree/$kver/kernel" ]]; then
+ ERROR_MESSAGES+=("Missing $kver kernel modules tree for module $mod/$mver.")
+ unset tobuild[$nvk]
+ continue
+ # postpone modules with missing dependencies
+ elif ! check_dependency "$mod" "$mver" "$kver"; then
+ continue
+ fi
+ # give it a try dkms
+ run dkms install --no-depmod "$mod/$mver" -k "$kver"
+ if (( $? == 0 )); then
+ # register kernel version for later depmod
+ depmods[$kver]=''
+ fi
+ unset tobuild[$nvk]
+ # maybe this module was a dep of another, so we retry
+ retry=1
+ done
+ done
+ # run depmod later for performance improvments
+ if (( $DKMS_DEPMOD )); then
+ for kver in "${!depmods[@]}"; do
+ run depmod "$kver"
+ done
+ fi
+ # add errors messages for missing dependencies modules
+ for nvk in "${!tobuild[@]}"; do
+ [[ "$nvk" =~ ([^/]+/[^/]+)/(.+) ]] || continue
+ nv="${BASH_REMATCH[1]}"
+ kver="${BASH_REMATCH[2]}"
+ ERROR_MESSAGES+=("Missing dependencies to install module $nv for kernel $kver.")
+ done
+}
+
+# remove registered modules
+# run depmod once per kernel for performance improvments
+dkms_remove() {
+ local nv kver
+ local -A depmods=()
+ # remove full modules first
+ for nv in "${!DKMS_MODULES[@]}"; do
+ # try to remove modules one by one to keep the depmod optimization
+ for kver in $(built_kver_from_nv "$nv"); do
+ run dkms remove --no-depmod "$nv" -k "$kver"
+ if (( $? == 0 )); then
+ # register kernel version for later depmod
+ depmods[$kver]=''
+ else
+ ERROR_MESSAGES+=("Failed to remove module $nv for kernel $kver.")
+ fi
+ done
+ # ensure module removal (even if only added)
+ if [[ $(dkms status "$nv") ]]; then
+ run dkms remove "$nv"
+ (( $? == 0 )) || ERROR_MESSAGES+=("Failed to remove module $nv.")
+ fi
+ done
+ # remove modules for a specific kernel version
+ for kver in "${!KERNEL_VERSIONS[@]}"; do
+ for nv in $(built_nv_from_kver "$kver"); do
+ run dkms remove --no-depmod "$nv" -k "$kver"
+ if (( $? == 0 )); then
+ # register kernel version for later depmod
+ depmods[$kver]=''
+ else
+ ERROR_MESSAGES+=("Failed to remove module $nv for kernel $kver.")
+ fi
+ done
+ done
+ # run depmod later for performance improvments
+ if (( $DKMS_DEPMOD )); then
+ for kver in "${!depmods[@]}"; do
+ run depmod "$kver"
+ done
+ fi
+}
+
+# display hook usage and exit $1 (default 1)
+usage() {
+ cat << EOF >&2
+usage: ${0##*/} <options> install|remove
+options: -D Do not run depmod
+EOF
+ exit ${1:-1}
+}
+
+# emulated program entry point
+main() {
+ [[ "$DKMS_ALPM_HOOK_DEBUG" ]] && set -x
+
+ # prevent each dkms call from failing with authorization errors
+ if (( EUID )); then
+ echo 'You must be root to use this hook' >&2
+ return 1
+ fi
+
+ # parse command line options
+ declare -i DKMS_DEPMOD=1
+ local opt
+ while getopts 'hD' opt; do
+ case $opt in
+ D) DKMS_DEPMOD=0;;
+ *) usage;;
+ esac
+ done
+ shift $((OPTIND - 1))
+ (( $# != 1 )) && usage
+
+ # parse command action to early exit
+ case "$1" in
+ install|remove) declare -r DKMS_ACTION="$1";;
+ *) usage;;
+ esac
+
+ # dkms path from framework config
+ # note: the alpm hooks which trigger this script use static path
+ source_tree='/usr/src'
+ install_tree='/usr/lib/modules'
+ source /etc/dkms/framework.conf
+
+ # check source_tree and install_tree exists
+ local path
+ for path in "$source_tree" "$install_tree"; do
+ if [[ ! -d "$path" ]]; then
+ echo "==> Missing mandatory directory: $path. Exiting!" >&2
+ return 1
+ fi
+ done
+
+ # global storage for changed DKMS modules
+ # we use associate arrays to prevent duplication
+ # the key is <module name>/<module version>/<kernel version>
+ declare -A DKMS_MODULES
+
+ # global storage for changed linux kernels
+ # we use associate arrays to prevent duplication
+ declare -A KERNEL_VERSIONS
+
+ # global storage for error messages
+ declare -a ERROR_MESSAGES
+
+ # parse stdin paths to guess what we should install/remove
+ while read -r path; do
+ if [[ "/$path" =~ ^$source_tree/([^/]+)-([^/]+)/dkms\.conf$ ]]; then
+ # we match file updates on dkms modules sources
+ DKMS_MODULES["${BASH_REMATCH[1]}/${BASH_REMATCH[2]}"]=''
+ elif [[ "/$path" =~ ^$install_tree/([^/]+)/ ]]; then
+ # we match file updates on kernels install/removal
+ KERNEL_VERSIONS["${BASH_REMATCH[1]}"]=''
+ fi
+ done
+
+ dkms_$DKMS_ACTION
+
+ # display errors at the end, to maximize readers
+ local msg
+ for msg in "${ERROR_MESSAGES[@]}"; do
+ echo "==> ERROR: $msg" >&2
+ done
+
+ return 0
+}
+
+main "$@"
Deleted: extra-any/hook.upgrade
===================================================================
--- extra-any/hook.upgrade 2021-11-15 09:53:58 UTC (rev 428524)
+++ extra-any/hook.upgrade 2021-11-15 11:46:25 UTC (rev 428525)
@@ -1,13 +0,0 @@
-[Trigger]
-Operation = Upgrade
-Type = Path
-Target = usr/src/*/dkms.conf
-Target = usr/lib/modules/*/build/include/
-Target = usr/lib/modules/*/modules.alias
-
-[Action]
-Description = Remove upgraded DKMS modules
-Depends = dkms
-When = PreTransaction
-Exec = /usr/lib/dkms/alpm-hook -D remove
-NeedsTargets
Copied: dkms/repos/extra-any/hook.upgrade (from rev 428524, dkms/repos/testing-any/hook.upgrade)
===================================================================
--- extra-any/hook.upgrade (rev 0)
+++ extra-any/hook.upgrade 2021-11-15 11:46:25 UTC (rev 428525)
@@ -0,0 +1,13 @@
+[Trigger]
+Operation = Upgrade
+Type = Path
+Target = usr/src/*/dkms.conf
+Target = usr/lib/modules/*/build/include/
+Target = usr/lib/modules/*/modules.alias
+
+[Action]
+Description = Remove upgraded DKMS modules
+Depends = dkms
+When = PreTransaction
+Exec = /usr/share/libalpm/scripts/dkms -D remove
+NeedsTargets
More information about the arch-commits
mailing list